> ## Documentation Index
> Fetch the complete documentation index at: https://docs.kukkingu.software/llms.txt
> Use this file to discover all available pages before exploring further.

# List projects

> Retrieves projects for the authenticated tenant.



## OpenAPI

````yaml https://api.contracting.kukkingu.software/api/v1/docs.json get /api/v1/projects
openapi: 3.1.0
info:
  title: Contracting Backend API
  version: 0.1.0
  description: API documentation for the Contracting backend service.
servers:
  - url: https://api.contracting.kukkingu.software
    description: API server
security:
  - bearerAuth: []
paths:
  /api/v1/projects:
    get:
      tags:
        - Projects
      summary: List projects
      description: Retrieves projects for the authenticated tenant.
      parameters:
        - schema:
            type: string
            example: contract,contract.client
            description: >-
              Comma-separated list of relations to expand. Allowed values:
              contract, contract.client.
          in: query
          name: expand
        - schema:
            type: string
            description: The ID of the contract.
            example: ctr_z23aoo8naxk68ewcr64tchh5
          in: query
          name: contractId
        - schema:
            type: string
            description: >-
              Comma-separated list of sort clauses in "field:direction" format.
              Allowed fields: name, order, createdAt, updatedAt, contract.name.
              Allowed directions: asc, desc.
            example: name:asc,order:desc
          in: query
          name: sort
        - schema:
            type: string
            example: tnt_pfh0haxfpzowht3oi213cqos
            description: >-
              Specifies the tenant context for the request. All endpoints
              operate within this tenant scope.
          in: header
          name: tenant-id
          required: true
          description: >-
            Specifies the tenant context for the request. All endpoints operate
            within this tenant scope.
      responses:
        '200':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    type: array
                    items:
                      type: object
                      properties:
                        id:
                          type: string
                          description: Unique identifier of the project.
                          example: prj_8f4d4gk1p9h2x0s7v3n5c1a9
                        contract:
                          anyOf:
                            - type: string
                              description: The ID of the contract.
                              example: ctr_z23aoo8naxk68ewcr64tchh5
                            - type: object
                              properties:
                                id:
                                  type: string
                                  description: The ID of the contract.
                                  example: ctr_z23aoo8naxk68ewcr64tchh5
                                client:
                                  anyOf:
                                    - type: string
                                      description: Unique identifier of the client.
                                      example: clnt_z2b3mo8qa5kzptgsu26q2wmh
                                    - type: object
                                      properties:
                                        id:
                                          type: string
                                          description: Unique identifier of the client.
                                          example: clnt_z2b3mo8qa5kzptgsu26q2wmh
                                        name:
                                          type: string
                                          minLength: 1
                                          maxLength: 255
                                          description: The name of the client.
                                          example: Acme Corporation
                                        description:
                                          type: string
                                          maxLength: 1024
                                          description: >-
                                            Additional information describing the
                                            client.
                                          example: >-
                                            A leading provider of road runner
                                            deterrents.
                                        order:
                                          type: integer
                                          minimum: 0
                                          maximum: 9007199254740991
                                          description: >-
                                            Order of the resource for sorting
                                            purposes.
                                          example: 13
                                        createdAt:
                                          type: string
                                          format: date-time
                                          pattern: >-
                                            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                          description: Timestamp when the client was created.
                                          example: '2023-10-05T14:48:00.000Z'
                                        updatedAt:
                                          type: string
                                          format: date-time
                                          pattern: >-
                                            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                          description: >-
                                            Timestamp when the client was last
                                            updated.
                                          example: '2023-10-05T14:48:00.000Z'
                                      required:
                                        - id
                                        - name
                                        - createdAt
                                        - updatedAt
                                      additionalProperties: false
                                      description: Client resource returned by the API.
                                  description: >-
                                    Expandable Client field represented either
                                    as an ID or a fully expanded object.
                                name:
                                  type: string
                                  minLength: 1
                                  maxLength: 255
                                  description: Contract name.
                                  example: Standard Service Contract
                                description:
                                  type: string
                                  description: Detailed contract description.
                                  example: >-
                                    This contract covers standard service terms
                                    and conditions.
                                amountMinor:
                                  type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                                  description: >-
                                    Monetary amount in minor units (e.g.,
                                    cents).
                                  example: 5000
                                currencyCode:
                                  type: string
                                  minLength: 3
                                  maxLength: 3
                                  description: ISO 4217 currency code.
                                  example: EUR
                                order:
                                  type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                                  description: Order of the resource for sorting purposes.
                                  example: 13
                                validFrom:
                                  type: string
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  description: Contract validity start date.
                                  example: '2023-10-05T14:48:00.000Z'
                                validTo:
                                  type: string
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  description: Contract validity end date.
                                  example: '2023-10-05T14:48:00.000Z'
                                createdAt:
                                  type: string
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  description: Timestamp when the contract was created.
                                  example: '2023-10-05T14:48:00.000Z'
                                updatedAt:
                                  type: string
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  description: >-
                                    Timestamp when the contract was last
                                    updated.
                                  example: '2023-10-05T14:48:00.000Z'
                              required:
                                - id
                                - client
                                - name
                                - amountMinor
                                - currencyCode
                                - createdAt
                                - updatedAt
                              additionalProperties: false
                              description: Contract resource returned by the API.
                          description: >-
                            Expandable Contract field represented either as an
                            ID or a fully expanded object.
                        name:
                          type: string
                          minLength: 1
                          maxLength: 255
                          description: Name of the project.
                          example: Website Redesign
                        description:
                          type: string
                          maxLength: 1024
                          description: Optional description of the project.
                          example: Revamp the corporate website for the 2025 launch.
                        order:
                          type: integer
                          minimum: 0
                          maximum: 9007199254740991
                          description: Order of the resource for sorting purposes.
                          example: 13
                        createdAt:
                          type: string
                          format: date-time
                          pattern: >-
                            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                          description: Timestamp when the project was created.
                          example: '2023-10-05T14:48:00.000Z'
                        updatedAt:
                          type: string
                          format: date-time
                          pattern: >-
                            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                          description: Timestamp when the project was last updated.
                          example: '2023-10-05T14:48:00.000Z'
                      required:
                        - id
                        - contract
                        - name
                        - createdAt
                        - updatedAt
                      additionalProperties: false
                      description: Project resource returned by the API.
                    description: List of projects returned by the API.
                required:
                  - data
                additionalProperties: false
                description: Standard success response payload wrapped in a data property.
        '401':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    default: Unauthorized
                    description: Machine-readable error code.
                    example: Unauthorized
                    type: string
                  message:
                    default: Unauthorized
                    description: Human-readable error message.
                    example: Unauthorized
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response for requests without valid authentication.
        '403':
          description: Default Response
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    default: Forbidden
                    description: Machine-readable error code.
                    example: Forbidden
                    type: string
                  message:
                    default: Forbidden
                    description: Human-readable error message.
                    example: Forbidden
                    type: string
                required:
                  - error
                  - message
                additionalProperties: false
                description: Error response for requests blocked by authorization rules.
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````